#! perl -w

# Licensed Materials - Property of IBM                       
# Component IBM Rational ROSE_RT BUILD : TARGET_RTS                 
# Copyright IBM Corporation 1999, 2008. All Rights Reserved.      
# U.S. Government Users Restricted Rights -  Use, duplication or    
# disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.



if( $#ARGV < 0 )
{
    print STDERR "Usage: ${0} [-f] [-R] file ...\n";
    exit 1;
}

$force = 0;
$recurse = 0;

while( $#ARGV >= 1 )
{
    if( $ARGV[0] eq '-f' ) { $force = 1; shift @ARGV; }
    elsif( $ARGV[0] eq '-R' ) { $recurse = 1; shift @ARGV; }
    else { last; }
}

sub rmtree
{
    my ( $dir ) = @_;
    my @all_entries=();
    my $entry;

    local *DIR;
    opendir DIR, "$dir" or die "Nasty [$dir] caused $!";
    @all_entries = grep !/^\.\.?$/, readdir DIR;
    closedir DIR;

    foreach $entry ( @all_entries )
    {
	if( -d "$dir/$entry" )
	{
	    &rmtree( "$dir/$entry" );
	}
	elsif( ! unlink( "$dir/$entry" ) && ! $force )
	{
	    print STDERR "$dir/$entry: $!\n";
	    exit 1;
	}
    }
    if( ! rmdir $dir && ! $force )
    {
	print STDERR "$dir: $!\n";
	exit 1;
    }
}

foreach $file ( @ARGV )
{
    next unless -e $file;

    if( -d $file and $recurse )
    {
	&rmtree( $file );
    }
    elsif( ! unlink( $file ) and ! $force )
    {
	print STDERR "$file: $!\n";
	exit 1;
    }
}
