# Licensed Materials - Property of IBM                       
# Component IBM Rational ROSE_RT BUILD : TARGET_RTS                 
# Copyright IBM Corporation 1999, 2008. All Rights Reserved.      
# U.S. Government Users Restricted Rights -  Use, duplication or    
# disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.



require 'tools/registry.pl';

$commonKey = 'HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\VisualStudio\\7.0';
$commonSub = 'InstallDir';

$vcKey     = "$commonKey\\Setup\\VC";
$vcSub     = 'ProductDir';

unless( $commonRoot = &ReadRegEntry( $commonKey, $commonSub, '' ) )
{
    print STDERR "Can't find registry VC location '$commonSub' at\n"
	       . "$commonKey\n\n";
    exit 1;
}

unless( $vcRoot = &ReadRegEntry( $vcKey, $vcSub, '' ) )
{
    print STDERR "Can't find registry VC location '$vcSub' at\n$vcKey\n\n";
    exit 1;
}

$ENV{'INCLUDE'} =  "$vcRoot\\INCLUDE"
		. ";$vcRoot\\ATLMFC\\INCLUDE"
		. ";$vcRoot\\PlatformSDK\\INCLUDE";

$ENV{'LIB'}     =  "$vcRoot\\LIB"
		. ";$vcRoot\\ATLMFC\\LIB"
		. ";$vcRoot\\PlatformSDK\\LIB";

$ENV{'PATH'}    = "$commonRoot"
		. ";$vcRoot\\BIN"
		. ";$vcRoot\\PlatformSDK\\BIN"
		. ";$ENV{'PATH'}";

$include_opt  = '/I';
@make_args    = ( '/nologo', '/f', '../src/main.nmk' );
$object_ext   = '.OBJ';
$preprocessor = "cl /nologo /EP /P";
$target_base  = 'NT40';
$supported    = 'Yes';
