/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTBoolean_h__
#define __RTBoolean_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTInteger_h__
#include <RTInteger.h>
#endif

class RTBoolean : public RTInteger
{
public:
			    RTBoolean( int = 0 /*false*/ ); //lint !e1931
			    RTBoolean( const RTBoolean & );
    virtual                 ~RTBoolean( void );

    RTBoolean             & operator=( const RTBoolean & );

    virtual const RTObject_class * getClassData( void ) const;
    static  const RTObject_class   classData;

#define RTType_RTBoolean ( RTBoolean::classData )
};

extern const RTBoolean RTTrue;
extern const RTBoolean RTFalse;

struct RTTypedValue_RTBoolean
{
    const void           * data;
    const RTObject_class * type;

    RTS_INLINE RTTypedValue_RTBoolean( const RTBoolean      & ); //lint !e1931
    RTS_INLINE RTTypedValue_RTBoolean( const RTBoolean      &,
				       const RTObject_class * );
}; //lint !e1712

#if RTS_INLINES
#include <RTBoolean.inl>
#endif

#endif // __RTBoolean_h__
