/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTCharacter_h__
#define __RTCharacter_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTDataObject_h__
#include <RTDataObject.h>
#endif

class RTCharacter : public RTDataObject
{
public:
    char                    value;

			    RTCharacter( char = ' ' ); //lint !e1931
			    RTCharacter( const RTCharacter & );
    virtual                 ~RTCharacter( void );

    RTCharacter           & operator= ( const RTCharacter  & );
    virtual int             operator==( const RTDataObject & ) const;
    operator char           ( void ) const;

    int                     asciiValue  ( void ) const;
    int                     isAlphabetic( void ) const;
    int                     isDigit     ( void ) const;
    int                     isLowerCase ( void ) const;
    int                     isSeparator ( void ) const;
    int                     isUpperCase ( void ) const;

    virtual const RTObject_class * getClassData( void ) const;
    static  const RTObject_class   classData;

#define RTType_RTCharacter ( RTCharacter::classData )
};

struct RTTypedValue_RTCharacter
{
    const void           * data;
    const RTObject_class * type;

    RTS_INLINE RTTypedValue_RTCharacter( const RTCharacter    & ); //lint !e1931
    RTS_INLINE RTTypedValue_RTCharacter( const RTCharacter    &,
					 const RTObject_class * );
}; //lint !e1712

#if RTS_INLINES
#include <RTCharacter.inl>
#endif

#endif // __RTCharacter_h__
