/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTCounts_h__
#define __RTCounts_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTPriority_h__
#include <RTPriority.h>
#endif

class RTCounts
{
public:
		RTCounts( void );

						    // numbers of
    unsigned    actorsIncarnated;                   // actors incarnated
    unsigned    actorsDestroyed;                    // actors destroyed

    unsigned    portsIncarnated;                    // ports incarnated
    unsigned    portsDestroyed;                     // ports destroyed

    unsigned    messagesAllocated;                  // messages allocated
    unsigned    peakMessagesAllocated;              // peak messages allocated

    unsigned    messagesInvoked;                    // messages invoked
    unsigned    messagesDelivered[OTRTS_NUMPRIO];   // messages delivered
    unsigned    messagesDropped;                    // messages queued
						    // but not delivered

    unsigned    timersStarted;                      // timeouts requested
    unsigned    timersExpired;                      // timeouts expired
    unsigned    timersCancelled;                    // timeouts cancelled

private:
    // unavailable methods
    RTCounts( const RTCounts & );
    RTCounts & operator=( const RTCounts & );
};

#endif // __RTCounts_h__
