/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTExceptionSignal_inl__
#define __RTExceptionSignal_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTExceptionSignal_h__
#include <RTExceptionSignal.h>
#endif

#ifndef __RTProtocol_h__
#include <RTProtocol.h>
#endif

#ifndef __RTTypedValue_h__
#include <RTTypedValue.h>
#endif

RTS_INLINE RTExceptionSignal::RTExceptionSignal( RTProtocol * port, int signal )
    : _port  ( port                      )
    , _signal( signal                    )
    , _data  ( (const void           *)0 )
    , _type  ( (const RTObject_class *)0 )
{
}

RTS_INLINE RTExceptionSignal::RTExceptionSignal( RTProtocol         * port,
						 int                  signal,
						 const RTTypedValue & value )
    : _port  ( port       )
    , _signal( signal     )
    , _data  ( value.data )
    , _type  ( value.type )
{
}

RTS_INLINE RTExceptionSignal::~RTExceptionSignal( void )
{
#ifdef _lint
    _port = (RTProtocol           *)0;
    _data = (const void           *)0;
    _type = (const RTObject_class *)0;
#endif
}

RTS_INLINE int RTExceptionSignal::raise( void )
{
    return _port->raise( _signal, _data, _type );
}

#endif // __RTExceptionSignal_inl__
