/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTGlobalSignal_h__
#define __RTGlobalSignal_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

class RTGlobalSignal
{
public:
    RTS_INLINE explicit         RTGlobalSignal( void );
    RTS_INLINE                  RTGlobalSignal( const RTGlobalSignal & );
    RTS_INLINE                  ~RTGlobalSignal( void );

    RTS_INLINE RTGlobalSignal & operator=( const RTGlobalSignal & );
    RTS_INLINE int              operator==( const RTGlobalSignal & ) const;

    static const RTGlobalSignal unknown;

private:
    const RTGlobalSignal      * original;
};

#if RTS_INLINES
#include <RTGlobalSignal.inl>
#endif

#endif // __RTGlobalSignal_h__
