/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTInterval_inl__
#define __RTInterval_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTInterval_h__
#include <RTInterval.h>
#endif

RTS_INLINE RTInterval::~RTInterval( void )
{
}

RTS_INLINE long RTInterval::micros( void ) const
{
    return usec;
}

RTS_INLINE long RTInterval::seconds( void ) const
{
    return sec;
}

RTS_INLINE int operator==( const RTInterval & lhs, const RTInterval & rhs )
{
    long lhs_s = lhs.seconds(); long lhs_u = lhs.micros();
    long rhs_s = rhs.seconds(); long rhs_u = rhs.micros();

    return ( lhs_s == rhs_s ) && ( lhs_u == rhs_u );
}

RTS_INLINE int operator>( const RTInterval & lhs, const RTInterval & rhs )
{
    return rhs < lhs;
}

RTS_INLINE int operator>=( const RTInterval & lhs, const RTInterval & rhs )
{
    return ( lhs < rhs ) == 0;
}

RTS_INLINE int operator!=( const RTInterval & lhs, const RTInterval & rhs )
{
    return ( lhs == rhs ) == 0;
}

RTS_INLINE int operator<=( const RTInterval & lhs, const RTInterval & rhs )
{
    return ( rhs < lhs ) == 0;
}

RTS_INLINE
RTTypedValue_RTInterval::
RTTypedValue_RTInterval( const RTInterval & _value )
    : data( &_value )
    , type( &RTType_RTInterval )
{
}

RTS_INLINE
RTTypedValue_RTInterval::
RTTypedValue_RTInterval( const RTInterval     & _value,
			 const RTObject_class * _type )
    : data( &_value )
    , type( _type   )
{
}

#endif // __RTInterval_inl__
