/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTLayerData_h__
#define __RTLayerData_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

class RTController;

class RTLayerData
{
public:
    RTS_INLINE           RTLayerData( void );
    virtual              ~RTLayerData( void );

    virtual const char * getRegisteredName( void ) const = 0;

    virtual void         resize( RTController * context, int old_size ) = 0;

    virtual void         deregister( RTController * context ) = 0;
};

#if RTS_INLINES
#include <RTLayerData.inl>
#endif

#endif // __RTLayerData_h__
