/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTString_h__
#define __RTString_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTDataObject_h__
#include <RTDataObject.h>
#endif

class RTString : public RTDataObject
{
public:
    char                  * Contents;

			    RTString( const char * = 0 ); //lint !e1931
			    RTString( const RTString  & );
    virtual                 ~RTString( void );

    RTString              & operator=( const char     * );
    RTS_INLINE RTString   & operator=( const RTString & );

    virtual int             operator==( const RTDataObject & ) const;
    int                     operator==( const char         * ) const;
    RTS_INLINE int          operator==( const RTString     & ) const;

    RTS_INLINE int          operator!=( const RTDataObject & ) const;
    RTS_INLINE int          operator!=( const char         * ) const;
    RTS_INLINE int          operator!=( const RTString     & ) const;

    RTS_INLINE operator char       * ( void );
    RTS_INLINE operator const char * ( void ) const;
    RTS_INLINE operator void       * ( void );
    char                  & operator[]( int );
    const char            & operator[]( int ) const;

    virtual const RTObject_class * getClassData( void ) const;
    static  const RTObject_class   classData;

#define RTType_RTString ( RTString::classData )
};

RTS_INLINE int operator==( const char *, const RTString & );
RTS_INLINE int operator!=( const char *, const RTString & );

struct RTTypedValue_RTString
{
    const void           * data;
    const RTObject_class * type;

    RTS_INLINE RTTypedValue_RTString( const RTString       & ); //lint !e1931
    RTS_INLINE RTTypedValue_RTString( const RTString       &,
				      const RTObject_class * );
}; //lint !e1712

#if RTS_INLINES
#include <RTString.inl>
#endif

#endif // __RTString_h__
