/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTArray_class.h>

RTArray_class::RTArray_class( int size, const RTObject_class * type )
{ //lint !e1927 !e1928
    _super          = (const RTObject_class *)0;
    _super_accessor = (RTSuperAccessFunction)0,
    _name           = (const char *)0;
    _version        = (RTVersionId)0;
    _size           = type->_size * (RTFieldOffset)size;
    _init_func      = RTarray_init;
    _copy_func      = RTarray_copy;
#if OBJECT_DECODE
    _decode_func    = RTarray_decode;
#endif
#if OBJECT_ENCODE
    _encode_func    = RTarray_encode;
#endif
    _destroy_func   = RTarray_destroy;
    _num_fields     = size;
    _fields         = &element;

    element.name     = (const char *)0;
    element.offset   = (RTFieldOffset)0;
    element.type     = type;
    element.modifier = (const RTTypeModifier *)0;
}
