/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTAsciiEncoding.h>
#include <RTMemoryUtil.h>
#include <RTObject_class.h>
#include <RTUnknownObject.h>

int RTAsciiEncoding::put( const void * data, const RTObject_class * type )
{
    if( type == (const RTObject_class *)0 )
	return put_address( data );

#if OBJECT_DECODE
    if( type == &RTType_RTUnknownObject )
    {
	const RTUnknownObject * unknown = (const RTUnknownObject *)data;

	if( RTMemoryUtil::strcmp( unknown->signature, "RTAsciiDecoding" ) == 0 )
	    return putCode( unknown->code, unknown->length, SpaceAround );
    }
#endif

    if( type->_name == (const char *)0 )
    {
	// anonymous type
    }
    else if( putType( type ) == 0 )
    {
	return 0;
    }

    return type->encode( data, this );
}
