/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTController.h>
#include <RTDebugger.h>
#include <RTMessage.h>

int RTController::send( RTActor              * receiver,
			int                    controlSignal,
			const void           * data,
			const RTObject_class * type,
			int                    priority )
{
    RTMessage * msg = newMsg();

    if( msg == (RTMessage *)0 )
    {
	setError( noMem, SystemService, (const void *)0, (const void *)0 );
	return 0;
    }

    msg->setData( data, type );
    msg->setSignal( controlSignal );
    msg->setPriority( priority );
    msg->setDestination( receiver, (RTProtocol *)0, 0 );
    msg->internData();

#if OBSERVABLE
    debugger()->setTimestamp( msg, (RTProtocol *)0, 0 );
#endif

    receiver->context()->receive( msg, this );

    return 1;
}
