/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTActorRef.h>
#include <RTActorRefProbe.h>
#include <RTDebugger.h>
#if USE_THREADS
#include <RTMutex.h>
#endif
#include <RTProbe.h>

void RTDebugger::actorDestroyed( RTActor * actor )
{
    RTProbe * probe;

#if USE_THREADS
    _mutex->enter();
#endif

    for( int i = 0; i < probes.size(); ++i )
    {
	if( ( probe = (RTProbe *)probes[ i ] ) != (RTProbe *)0 &&
	      probe->disconnectProbe( actor ) != 0 )
	{
	    parkedProbes[ parkedProbes.unusedIndex() ] = (void *)probe;
	    ++nrParkedProbes;
	}
    }

    RTActorRef * homeRef = actor->getReference();

    if( homeRef != (RTActorRef *)0 && homeRef->probe != (RTActorRefProbe *)0 )
	homeRef->probe->evtPresence( actor->getIndex(), -1, -1 );

#if USE_THREADS
    _mutex->leave();
#endif
}
