/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActorProbe.h>
#include <RTDaemonInfo.h>
#include <RTDebugger.h>

#if USE_THREADS
#include <RTMutex.h>
#endif

int RTDebugger::inject( int                    inwards,
			const char           * signal,
			int                    prio,
			const void           * data,
			const RTObject_class * type,
			const RTDaemonInfo   & daemonInfo )
{
#if USE_THREADS
    _mutex->enter();
#endif

    RTActorProbe * probe  = (RTActorProbe *)probes[ daemonInfo.probeNr ];
    int            result = ( probe != (RTActorProbe *)0 )
				? probe->inject( inwards, signal, prio,
						 data, type, daemonInfo )
				: 0;

#if USE_THREADS
    _mutex->leave();
#endif

    return result;
}
