/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTElasticArray.h>

RTElasticArray::RTElasticArray( int initial_size )
    : _size    ( initial_size )
    , _contents( (void **)0   )
{
    if( _size <= 0 )
	_size = 0;
    else
    {
	_contents = new void * [ (unsigned)_size ];

	for( int i = 0; i < _size; ++i )
	    _contents[i] = (void *)0;
    }
}

RTElasticArray::RTElasticArray( const RTElasticArray & other )
    : _size    ( other._size )
    , _contents( (void **)0  )
{
    if( _size <= 0 )
	_size = 0;
    else
    {
	_contents = new void * [ (unsigned)_size ];

	for( int i = 0; i < _size; ++i )
	    _contents[i] = other._contents[i];
    }
}
