/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTArray_class.h>
#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTTypeModifier.h>

static void array_destroy( const RTObject_class * element,
			   void                 * target,
			   int                    size,
			   int                    indirect )
{
    RTArray_class   array( size, element );
    void          * target_array;

    if( indirect == 0 )
	array.destroy( target, RTObject_class::DestroyOnly );
    else if( (target_array = *(void **)target) != (void *)0 )
    {
	*(void **)target = (void *)0;

	array.destroy( target_array, RTObject_class::DestroyAndDeallocate );
    }
}

void RTFieldDescriptor::destroy( void * target ) const
{
    void * field = RTObjectOf( void, offset, target );

    if( modifier == (const RTTypeModifier *)0 )
	(*type->_destroy_func)( type, field );
    else
	array_destroy( type, field,
		       (*modifier->_num_elements_func)( modifier, target ),
		       modifier->_indirect );
}
