/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTFieldDescriptor.h>
#include <RTInteger.h>
#include <RTObject_class.h>
#include <RTnew.h>

static RTDataObject * _access( RTInteger * target )
{
    return target;
}

static void _init( const RTObject_class *, void * target )
{
    (void)new( target ) RTInteger;
}

static void _copy( const RTObject_class *,
		   void                 * target,
		   const void           * source )
{
    (void)new( target ) RTInteger( *(const RTInteger *)source );
}

#if OBJECT_DECODE
static int _decode( const RTObject_class *,
		    void                 * target,
		    RTDecoding           * coding )
{
    RTInteger * data = (RTInteger *)target;

    return coding->get_int( data->value );
}
#endif

#if OBJECT_ENCODE
static int _encode( const RTObject_class *,
		    const void           * source,
		    RTEncoding           * coding )
{
    const RTInteger * data = (const RTInteger *)source;

    return coding->put_int( data->value );
}
#endif

static const RTFieldDescriptor _fields[] =
{
    {
	"RTInteger",
	(RTFieldOffset)0,
	&RTInteger::classData,
	(const RTTypeModifier *)0
    }
};

const RTObject_class RTInteger::classData =
{
    &RTType_RTDataObject,
    (RTSuperAccessFunction)_access,
    "RTInteger",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( RTInteger ),
    _init,
    _copy,
#if OBJECT_DECODE
    _decode,
#endif
#if OBJECT_ENCODE
    _encode,
#endif
    RTDataObject_destroy,
    1, _fields
};

#if OBJECT_DECODE
RTTypeInstaller RTInteger_installer( RTType_RTInteger );
#endif

const RTObject_class * RTInteger::getClassData( void ) const
{
    return &RTInteger::classData;
}
