/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTFieldDescriptor.h>
#include <RTInterval.h>
#include <RTnew.h>

static void _init( const RTObject_class *, void * target )
{
    (void)new( target ) RTInterval;
}

static void _copy( const RTObject_class *,
		   void                 * target,
		   const void           * source )
{
    (void)new( target ) RTInterval( *(const RTInterval *)source );
}

static void _destroy( const RTObject_class *, void * target )
{
    ((RTInterval *)target)->~RTInterval();
}

const RTFieldDescriptor RTInterval::fieldData[] =
{
    {
	"sec",
	RTOffsetOf( RTInterval, sec ),
	&RTType_long,
	(const RTTypeModifier *)0
    },
    {
	"usec",
	RTOffsetOf( RTInterval, usec ),
	&RTType_long,
	(const RTTypeModifier *)0
    }
};

const RTObject_class RTInterval::classData =
{
    (const RTObject_class *)0,
    (RTSuperAccessFunction)0,
    "RTInterval",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( RTInterval ),
    _init,
    _copy,
#if OBJECT_DECODE
    RTstruct_decode,
#endif
#if OBJECT_ENCODE
    RTstruct_encode,
#endif
    _destroy,
    2, RTInterval::fieldData
};

#if OBJECT_DECODE
RTTypeInstaller RTInterval_installer( RTType_RTInterval );
#endif
