/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTObject_class.h>

static void int_init( const RTObject_class *, void * target )
{
    *(int *)target = 0;
}

static void int_copy( const RTObject_class *,
		      void                 * target,
		      const void           * source )
{
    *(int *)target = *(const int *)source;
}

#if OBJECT_DECODE
static int int_decode( const RTObject_class *,
		       void                 * target,
		       RTDecoding           * coding )
{
    return coding->get_int( *(int *)target );
}
#endif

#if OBJECT_ENCODE
static int int_encode( const RTObject_class *,
		       const void           * source,
		       RTEncoding           * coding )
{
    return coding->put_int( *(const int *)source );
}
#endif

const RTObject_class RTType_int =
{
    (RTObject_class *)0,
    (RTSuperAccessFunction)0,
    "int",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( int ),
    int_init,
    int_copy,
#if OBJECT_DECODE
    int_decode,
#endif
#if OBJECT_ENCODE
    int_encode,
#endif
    RTnop_destroy,
    0, (const RTFieldDescriptor *)0
};

#if OBJECT_DECODE
RTTypeInstaller int_installer( RTType_int );
#endif
