/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTObject_class.h>

static void short_init( const RTObject_class *, void * target )
{
    *(short *)target = 0;
}

static void short_copy( const RTObject_class *,
			void                 * target,
			const void           * source )
{
    *(short *)target = *(const short *)source;
}

#if OBJECT_DECODE
static int short_decode( const RTObject_class *,
			 void                 * target,
			 RTDecoding           * coding )
{
    return coding->get_short( *(short *)target );
}
#endif

#if OBJECT_ENCODE
static int short_encode( const RTObject_class *,
			 const void           * source,
			 RTEncoding           * coding )
{
    return coding->put_short( *(const short *)source );
}
#endif

const RTObject_class RTType_short =
{
    (RTObject_class *)0,
    (RTSuperAccessFunction)0,
    "short",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( short ),
    short_init,
    short_copy,
#if OBJECT_DECODE
    short_decode,
#endif
#if OBJECT_ENCODE
    short_encode,
#endif
    RTnop_destroy,
    0, (const RTFieldDescriptor *)0
};

#if OBJECT_DECODE
RTTypeInstaller short_installer( RTType_short );
#endif
