/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTPriority.h>
#include <RTnew.h>

static RTInteger * _access( RTPriority * target )
{
    return target;
}

static void _init( const RTObject_class *, void * target )
{
    (void)new( target ) RTPriority;
}

static void _copy( const RTObject_class *,
		   void                 * target,
		   const void           * source )
{
    (void)new( target ) RTPriority( *(const RTPriority *)source );
}

static const RTFieldDescriptor _fields[] =
{
    {
	"RTPriority",
	(RTFieldOffset)0,
	&RTPriority::classData,
	(const RTTypeModifier *)0
    }
};

const RTObject_class RTPriority::classData =
{
    &RTType_RTInteger,
    (RTSuperAccessFunction)_access,
    "RTPriority",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( RTPriority ),
    _init,
    _copy,
#if OBJECT_DECODE
    RTinherit_decode,
#endif
#if OBJECT_ENCODE
    RTinherit_encode,
#endif
    RTDataObject_destroy,
    1, _fields
};

#if OBJECT_DECODE
RTTypeInstaller RTPriority_installer( RTType_RTPriority );
#endif

const RTObject_class * RTPriority::getClassData( void ) const
{
    return &RTPriority::classData;
}
