/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTObject_class.h>
#include <RTProtocolDescriptor.h>
#include <RTSignalDescriptor.h>

RTProtocolDescriptor::Status
RTProtocolDescriptor::canReceive( int                    signal,
				  const RTObject_class * type ) const
{
    const RTSignalDescriptor * rxSignal = inSignals;
    int                        rxCount  = numInSignals;

    for( ; --rxCount >= 0; ++rxSignal )
    {
	if( rxSignal->value == signal )
	{
	    if( rxSignal->type == (const RTObject_class *)0 )
		return ok; // any type is acceptable
	    else if( type == (const RTObject_class *)0 )
		return badType; // need a specific type
	    else if( type->isKindOf( rxSignal->type ) != 0 )
		return ok; // this type is acceptable
	    else
		return badType; // this type is not acceptable
	}
    }

    return badSignal; // no such signal
}
