/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTQueue.h>

RTQueue & RTQueue::operator=( const RTQueue & rhs )
{
    if( this != &rhs )
    {
	Iterator   iterator( rhs );
	void     * data  = iterator.next();
	Block    * block = head;
	Block    * prev  = (Block *)0;

	if( block != (Block *)0 )
	{
	    block->used = 0;

	    for(;;)
	    {
		if( data == (void *)0 )
		{
		    if( block->used == 0 )
		    {
			if( prev == (Block *)0 )
			    head       = (Block *)0;
			else
			    prev->next = (Block *)0;
			tail = prev;

			do
			{
			    prev  = block;
			    block = block->next;

			    delete prev;
			}
			while( block != (Block *)0 );
		    }
		    break;
		}

		if( block->used >= Block::Size )
		{
		    prev = block;
		    if( (block = block->next) == (Block *)0 )
			break;

		    block->used = 0;
		}

		block->data[ block->used++ ] = data;
		data = iterator.next();
	    }
	}

	for( ; data != (void *)0; data = iterator.next() )
	    add( data );
    }

    return *this;
}
