/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTReal.h>
#include <RTnew.h>

static RTDataObject * _access( RTReal * target )
{
    return target;
}

static void _init( const RTObject_class *, void * target )
{
    (void)new( target ) RTReal;
}

static void _copy( const RTObject_class *,
		   void                 * target,
		   const void           * source )
{
    (void)new( target ) RTReal( *(const RTReal *)source );
}

#if OBJECT_DECODE
static int _decode( const RTObject_class *,
		    void                 * target,
		    RTDecoding           * coding )
{
    RTReal * data = (RTReal *)target;

    return coding->get_double( data->value );
}
#endif

#if OBJECT_ENCODE
static int _encode( const RTObject_class *,
		    const void           * source,
		    RTEncoding           * coding )
{
    const RTReal * data = (const RTReal *)source;

    return coding->put_double( data->value );
}
#endif

static const RTFieldDescriptor _fields[] =
{
    {
	"RTReal",
	(RTFieldOffset)0,
	&RTReal::classData,
	(const RTTypeModifier *)0
    }
};

const RTObject_class RTReal::classData =
{
    &RTType_RTDataObject,
    (RTSuperAccessFunction)_access,
    "RTReal",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( RTReal ),
    _init,
    _copy,
#if OBJECT_DECODE
    _decode,
#endif
#if OBJECT_ENCODE
    _encode,
#endif
    RTDataObject_destroy,
    1, _fields
};

#if OBJECT_DECODE
RTTypeInstaller RTReal_installer( RTType_RTReal );
#endif

const RTObject_class * RTReal::getClassData( void ) const
{
    return &RTReal::classData;
}
