/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActorClass.h>
#include <RTActorId.h>
#include <RTDiag.h>
#include <RTMain.h>
#include <RTSuperActor.h>
#include <RTSystemDescriptor.h>
#include <RTTimerActor.h>

#if USE_THREADS
#include <RTThread.h>
#include <RTTimerController.h>
#endif

void RTSuperActor::t1_initialize( void )
{
    RTActorId id;

    // create threads and special actors

#if USE_THREADS
    const RTSystemDescriptor * system = RTMain::systemInfo();

    timerController = new RTTimerController( context()->debugger() );
    timerThread     = new RTThread( timerController, system->timerStackSize,
						     system->timerPriority );
#else
    RTController * timerController = context();
#endif

    id = frame.incarnate( specials, RTTimerActor::classData,
			  (const void *)0, (const RTObject_class *)0,
			  timerController, 0 ); //lint !e1901
    RTAssert( id.isValid() != 0 );

    RTMain::_topReference = &application;

    if( timer.informIn( RTTimespec::zero ) == (RTTimerNode *)0 )
	RTDiag::panic( "super timer" );
}
