/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTSpecialPorts.h>
#include <RTSpecialSignals.h>
#include <RTSuperActor.h>

void RTSuperActor::rtsBehavior( int _signal, int _port )
{
    switch( _port )
    {
    case RTControlPort:
	if( _signal == RTInitSignal )
	{
	    switch( getCurrentState() )
	    {
	    case 1: // top
		t1_initialize();
		enterState( 2 );
		return;
	    case 2: // starting
	    case 3: // running
		return;
	    default:
		break;
	    }
	}
	break;
    case rtid_timer:
	if( _signal == Timing::Base::rti_timeout )
	{
	    if( getCurrentState() == 2 ) // starting
	    {
		exitState( rtg_parent_state );
		t2_start();
		enterState( 3 );
		return;
	    }
	}
	break;
    default:
	break;
    }

    unexpectedMessage();
}
