/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTFormat.h>
#include <RTTcpSocket.h>
#include <RTinet.h>
#include <RTtcp.h>

int RTTcpSocket::getLocalName( char * name, int size ) const
{
    if( _sd == INET_NO_SOCKET )
	return 0;

    RTinet_address address;
    RTinet_port    port;

    if( RTinet_getname( _sd, &address, &port ) == 0 )
	return 0;

    char * cursor = (char *)&address;

    if( *cursor == '\0' && getPrimary( cursor ) == 0 )
	return 0;

    int i = sizeof( address );

    for(;;)
    {
	int len = RTFormat::_int( *cursor++ & 0xFF, name, size );

	if( len == 0 )
	    return 0;

	name += len;
	size -= len;

	if( --i <= 0 )
	    break;

	if( size <= 0 )
	    return 0;
	*name++ = '.';
    }

    if( size <= 0 )
	return 0;

    *name = '\0';

    return 1;
}
