/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTTimerId.h>
#include <RTTimerNode.h>

RTTimerId & RTTimerId::operator=( const RTTimerId & other )
{
    if( this == &other )
    {
	// do nothing: assignment from self
    }
    else if( node == (RTTimerNode *)0 && other.node == (RTTimerNode *)0 )
    {
	// do nothing: both invalid
    }
    else
    {
#if USE_THREADS
	RTTimerNode::critical.enter();
#endif

	if( node != other.node )
	{
	    if( node != (RTTimerNode *)0 )
		RTTimerNode::_disconnect( this );

	    if( other.node != (RTTimerNode *)0 )
		other.node->_connect( this );
	}

#if USE_THREADS
	RTTimerNode::critical.leave();
#endif
    }

    return *this;
}

RTTimerId & RTTimerId::operator=( RTTimerNode * n )
{
    if( node != (RTTimerNode *)0 || n != (RTTimerNode *)0 )
    {
#if USE_THREADS
	RTTimerNode::critical.enter();
#endif

	if( node != n )
	{
	    if( node != (RTTimerNode *)0 )
		RTTimerNode::_disconnect( this );

	    if( n != (RTTimerNode *)0 )
		n->_connect( this );
	}

#if USE_THREADS
	RTTimerNode::critical.leave();
#endif
    }

    return *this;
}
