/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTMessage.h>
#include <RTTimerId.h>
#include <RTSpecialSignals.h>
#include <RTTimerNode.h>

static const RTTimerId empty;

void RTTimerNode::buildMsg( RTMessage * message,
			    RTActor   * receiver,
			    int         priority )
{
    message->setDestination( receiver, (RTProtocol *)0, 0 );
    message->setSignal( RTPendingTimeoutSignal );
    message->setPriority( priority );
    message->setData( (const void *)&empty, &RTType_RTTimerId );
    message->internData();

    // Modify the timer id directly because the mutex is locked.
    _connect( (RTTimerId *)message->data );
}
