/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDaemon.h>
#include <RTDaemonInfo.h>
#include <RTEventInfo.h>
#include <RTMemoryUtil.h>
#include <RTToolsetObserver.h>

int RTToolsetObserver::evtChain( int                  daemonId,
				 const RTDaemonInfo & daemonInfo,
				 const RTEventInfo  & eventInfo )
{
    const RTDaemon * theDaemon = (const RTDaemon *)daemons[ daemonId ];

    if( theDaemon == (const RTDaemon *)0 )
	return 0;

    int shouldHalt = theDaemon->shouldHalt();

    if( theDaemon->shouldReport() == 0 )
	return shouldHalt;

    TO_evtChain   toSendData;
    TO_daemonInfo toDaemonInfo;

    toDaemonInfo.number   = daemonId;
    toDaemonInfo.invokeID = (char *)0;

    char * tempActor   = buildString( daemonInfo.actorPath,
				      eventInfo.actorIndex );

    toSendData.time.sec  = eventInfo.timestamp.tv_sec;
    toSendData.time.nsec = eventInfo.timestamp.tv_nsec;

    toSendData.actor = tempActor;
    toSendData.state = RTMemoryUtil::strdup( eventInfo.chainStrOrigin );
    toSendData.chain = RTMemoryUtil::strdup( eventInfo.chainStrTrans  );

    if( TO_encodeEvtChain( &txBuffer, &toDaemonInfo, &toSendData )
			  == ENC_SUCCESS )
    {
	sendTxBuffer();
    }

    delete [] toSendData.chain;
    delete [] toSendData.state;
    delete [] toSendData.actor;

    return shouldHalt;
}
