/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDaemon.h>
#include <RTDebugger.h>
#include <RTToolsetObserver.h>

void RTToolsetObserver::handleDaemon( void )
{
    sendResultCode( RES_OK );

    switch( structInfo.func )
    {
    case CMD_CREATE_DAEMON:
	cmdCreateDaemon( structInfo.daemon.number );
	(void)setDaemon( structInfo.daemon.number );
	daemon->updateSettings( ((TO_daemonSett *)structInfo.ptr)->settings );
	debugger->evtRtsStatus( observerId );
	break;

    case CMD_UPDATE_DAEMON:
	daemon->updateSettings( ((TO_daemonSett *)structInfo.ptr)->settings );
	break;

    case CMD_DESTROY_DAEMON:
	cmdDestroyDaemon( structInfo.daemon.number );
	break;

    case CMD_COMMAND_DAEMON:
	cmdCommand( ((TO_daemonSett *)structInfo.ptr)->settings );
	break;

    case CMD_REFRESH_DAEMON:
	daemon->updateSettings( ((TO_daemonSett *)structInfo.ptr)->settings );
	daemon->refresh( observerId, structInfo.daemon.number );
	break;

    default:
	break;
    }
}
