/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTFieldDescriptor.h>
#include <RTWrapper.h>
#include <RTnew.h>

static void _init( const RTObject_class *, void * target )
{
    (void)new( target ) RTWrapper;
}

static void _copy( const RTObject_class *,
		   void                 * target,
		   const void           * source )
{
    (void)new( target ) RTWrapper( *(const RTWrapper *)source );
}

#if OBJECT_DECODE
static int _decode( const RTObject_class *,
		    void                 * target,
		    RTDecoding           * coding )
{
    void                 * data;
    const RTObject_class * type;

    if( coding->get( &data, &type ) == 0 )
	return 0;
    else
    {
	RTWrapper new_value( data, type );

	*(RTWrapper *)target = new_value;
    }

    return 1;
}
#endif

#if OBJECT_ENCODE
static int _encode( const RTObject_class *,
		    const void           * source,
		    RTEncoding           * coding )
{
    const RTWrapper * wrapper = (const RTWrapper *)source;

    return wrapper->type()->encode( wrapper->data(), coding );
}
#endif

static void _destroy( const RTObject_class *, void * target )
{
    ((RTWrapper *)target)->~RTWrapper();
}

const RTObject_class RTWrapper::classData =
{
    (const RTObject_class *)0,
    (RTSuperAccessFunction)0,
    "RTWrapper",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( RTWrapper ),
    _init,
    _copy,
#if OBJECT_DECODE
    _decode,
#endif
#if OBJECT_ENCODE
    _encode,
#endif
    _destroy,
    0, (const RTFieldDescriptor *)0
};

#if OBJECT_DECODE
RTTypeInstaller RTWrapper_installer( RTType_RTWrapper );
#endif
