/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __endePriv_h__
#define __endePriv_h__ included

#ifndef __endeBoth_h__
#include <endeBoth.h>
#endif

#ifdef __cplusplus
extern "C"
{
#endif

/*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
||
||  Table lookup typedefs:
||
+|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*/

typedef int  ( * decoFunc )( TO_bufferInfo *, TO_structInfo * );
typedef void ( * freeFunc )( TO_structInfo * );

/*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
||
||  PRIVATE! Do Not Use!
||
+|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*/

/* Toolset decode: */
int decResultCo( TO_bufferInfo *, TO_structInfo * );
int decEvtTargI( TO_bufferInfo *, TO_structInfo * );
int decEvtPrese( TO_bufferInfo *, TO_structInfo * );
int decEvtRefer( TO_bufferInfo *, TO_structInfo * );
int decEvtChain( TO_bufferInfo *, TO_structInfo * );
int decEvtVaria( TO_bufferInfo *, TO_structInfo * );
int decEvtMsgOu( TO_bufferInfo *, TO_structInfo * );
int decEvtMsgIn( TO_bufferInfo *, TO_structInfo * );
int decEvtMsgOI( TO_bufferInfo *, TO_structInfo * );
int decEvtRtsSt( TO_bufferInfo *, TO_structInfo * );
int decEvtHisto( TO_bufferInfo *, TO_structInfo * );
/* Target decode: */
int decCmdCreDa( TO_bufferInfo *, TO_structInfo * ); /* Create daemon */
int decCmdUpdDa( TO_bufferInfo *, TO_structInfo * ); /* Update  */
int decCmdCmdDa( TO_bufferInfo *, TO_structInfo * ); /* Command */
int decCmdRefDa( TO_bufferInfo *, TO_structInfo * ); /* Refresh */
int decCmdAddAc( TO_bufferInfo *, TO_structInfo * ); /* Add actor */
int decCmdDelAc( TO_bufferInfo *, TO_structInfo * ); /* Delete */
int decCmdAddPo( TO_bufferInfo *, TO_structInfo * ); /* Add port */
int decCmdDelPo( TO_bufferInfo *, TO_structInfo * ); /* Delete */
int decCmdAddSt( TO_bufferInfo *, TO_structInfo * ); /* Add state */
int decCmdDelSt( TO_bufferInfo *, TO_structInfo * ); /* Delete */
int decCmdAddCh( TO_bufferInfo *, TO_structInfo * ); /* Add chain */
int decCmdDelCh( TO_bufferInfo *, TO_structInfo * ); /* Delete */
int decCmdAddVa( TO_bufferInfo *, TO_structInfo * ); /* Add variable */
int decCmdDelVa( TO_bufferInfo *, TO_structInfo * ); /* Delete */
int decCmdSetVa( TO_bufferInfo *, TO_structInfo * ); /* Set variable */
int decCmdGetVa( TO_bufferInfo *, TO_structInfo * ); /* Get */
int decCmdInjec( TO_bufferInfo *, TO_structInfo * ); /* Inject Msg */

/* Toolset free: */
void freeEvtTargI( TO_structInfo * );
void freeEvtPrese( TO_structInfo * );
void freeEvtRefer( TO_structInfo * );
void freeEvtChain( TO_structInfo * );
void freeEvtVaria( TO_structInfo * );
void freeEvtMsgOu( TO_structInfo * );
void freeEvtMsgIn( TO_structInfo * );
void freeEvtMsgOI( TO_structInfo * );
void freeEvtHisto( TO_structInfo * );
/* Target free: */
void freeCmdDaemo( TO_structInfo * );
void freeCmdActor( TO_structInfo * );
void freeCmdPort ( TO_structInfo * );
void freeCmdState( TO_structInfo * );
void freeCmdChain( TO_structInfo * );
void freeCmdAdDeV( TO_structInfo * );
void freeCmdSeGeV( TO_structInfo * );
void freeCmdInjec( TO_structInfo * );

void freeStr( char * );

/*----------------------------------------------------------------------------
|  Common decoding functions:
+---------------------------------------------------------------------------*/

/*--- Basic decoding - Int, Str, Func: -------------------------------------*/

int doDecodeInt( TO_bufferInfo *, int   * pIntValue );
int doDecodeStr( TO_bufferInfo *, char ** pStrValue );

/*--- Semi-special decoding: -----------------------------------------------*/

/*--- Decoding data struct initialization: ---------------------------------*/

void * initStructInfo( TO_structInfo *, int type );

/*----------------------------------------------------------------------------
|  Common encoding functions:
+---------------------------------------------------------------------------*/

/*--- Basic encoding - Int, Str, Func: -------------------------------------*/

int doEncodeInt( TO_bufferInfo *, int          value );
int doEncodeStr( TO_bufferInfo *, const char * value );

/*--- Semi-special encoding: -----------------------------------------------*/

int doEncodeTimeStamp ( TO_bufferInfo *, const TO_timeStamp  * );
int doEncodeMessage   ( TO_bufferInfo *, const TO_message    * );

int doEncodeFuncDaemon( TO_bufferInfo *, int func, const TO_daemonInfo * );

#ifdef __cplusplus
}
#endif

#endif // __endePriv_h__
