/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTThreadInfo_h__
#define __RTThreadInfo_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTNucleus_h__
#include <RTNucleus.h>
#endif

#ifndef __RTSyncObject_h__
#include <RTSyncObject.h>
#endif

class RTJob;

struct RTThreadInfo
{
    RTJob        * job;
    char         * stack;
    NU_TASK        task;
    int            done;
    RTSyncObject   sync;

    RTThreadInfo( RTJob * );
    ~RTThreadInfo( void );

private:
    // unavailable methods
    RTThreadInfo( const RTThreadInfo & );
    RTThreadInfo & operator=( const RTThreadInfo & );
};

#endif // __RTThreadInfo_h__
