/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTWinCE.h>

void RTConsole::makeCaret( CaretState desired )
{
    if( caretState == desired )
	return;

    if( caretState == CaretDestroyed )
    {
	CreateCaret( window, (HBITMAP)0, character.width, character.height );
	if( desired == (caretState = CaretHidden) )
	    return;
    }

    if( desired == CaretVisible )
    {
	int screen_row = cursor.row - screen.top;
	int screen_col = cursor.col - screen.left;

	if( haveFocus == 0 || screen_row < 0 || screen.rows < screen_row ||
			      screen_col < 0 || screen.cols < screen_col )
	{
	    caretState = CaretHidden;
	}
	else
	{
	    SetCaretPos( screen_col * character.width,
			 screen_row * character.height );
	    ShowCaret( window );
	    caretState = CaretVisible;
	}
    }
    else
    {
	if( caretState == CaretVisible )
	    HideCaret( window );
	if( desired == CaretDestroyed )
	    DestroyCaret();
	caretState = desired;
    }
}
