/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTWinCE.h>

int RTConsole::readChar( void )
{
    RTConsole * console = soleInstance;

    if( console == (RTConsole *)0 )
    {
	static const char   eof[]  = "\nquit\n";
	static const char * cursor = eof;

	if( *cursor == '\0' )
	    cursor = eof;

	return (int)*cursor++;
    }
    else
    {
	// We are misusing the RTSyncObject here, but because we
	// know it is implemented with a Win32 event, this is safe.
	console->input_available.wait();

	console->input_mutex.enter();

	char ch = console->input.data[ console->input.head++ ];

	if( console->input.head >= console->input.Size )
	    console->input.head  = 0;

	if( ch != '\n' || --console->input.lines != 0 )
	    console->input_available.signal();

	console->input_mutex.leave();

	return (int)ch;
    }
}
